
/////////////////////////////////////////////////////////////////////////////
//
//             /
//      -  P  /  E  C  E  -
//           /                 mobile equipment
//
//              System Programs
//
//
// PIECE KERNEL : Ver 1.00
//
// Copyright (C)2001 AUQAPLUS Co., Ltd. / OeRSTED, Inc. all rights reserved.
//
// Coded by MIO.H (OeRSTED)
//
// Comments:
//
//  tbVɍ\t@CVXe̊ǗłB
//
//  v1.00 2001.11.09 MIO.H
//  v1.03 2001.11.20 MIO.H VK쐬Et@CTCY̕ύXT|[g
//  v1.06 2001.11.24 MIO.H opensُ̈폑݂ɑΉ
//  v1.07 2001.11.28 MIO.H Kȃp[^ɂُ폑݂ɑΉ
//  v1.14 2001.12.21 MIO.H t@C̓K`FbN
//  v1.19 2003.02.25 N.SAWA 512KB/2MBΉ̕⏕=>FATAlloc():512KBisd.exeŏFAT㔼ɂȂ󋵂ւ̑Ή
//
//  v1.20 2004.05.03 Madoka MMCpext@Csׂ̊֐FXƒǉ
//


#include <piece.h>
#include <string.h>
#include "pcekn.h"
#include "piecezl.h"
#include "mmc_api.h"

#define BLOCKSIZE 4096

typedef struct tagWORKS {
	DIRECTORY *pdir;
} WORKS;


static zlibIO wkin;
static zlibIO wkout;
static FILEACC facc;

static pffsMASTERBLOCK *msb;
static unsigned long wklen;
static unsigned short bpos;


static int check_fname( const char *p )
{
	int i;

	for ( i = 0; i < 2; i++ ) {
		int c = 0;
		char a;

		while ( 1 ) {
			a = *p++;
			if ( !(		// t@Cɋ镶Zbg [0-9a-z_]
				( a >= '0' && a <= '9' ) ||
				( a >= 'a' && a <= 'z' ) ||
				( a == '_' )
				) ) break;
			c++;
		}

//		printf( "[%d]", c );

		if ( i == 0 ) {
			if ( c == 0 || c > 8 ) return 1;
			if ( !a ) return 0;
			if ( a != '.' ) return 2;
		}
		else {
			if ( c == 0 || c > 3 ) return 3;
			if ( !a ) return 0;
		}
	}

	return 4;
}




static DIRECTORY *Search( WORKS *pw )
{
	while ( 1 ) {
		DIRECTORY *p = pw->pdir++;
		int a;
		if ( p - msb->dir >= MAXDIR ) return NULL;
		a = p->name[0] & 255;
		if ( a != 0 && a != 255 ) return p;
	}
}

static DIRECTORY *SearchFile( const char *fname )
{
	DIRECTORY *pdir;

	{
		WORKS wk0;
		wk0.pdir = msb->dir;

		while ( 1 ) {
			pdir = Search( &wk0 );
			if ( pdir == NULL ) break;
			if ( !strcmp( pdir->name, fname ) ) break;
		}
	}

	return pdir;
}

static int FATAlloc( FAT *fat, int i )
{
//	for ( ; i < MAXFAT; i++ ) {
	int MAXFAT2 = ((PFFSEND - PFFSTOP) >> 12);	// 2003.02.25 N.SAWA 512KBisd.exeŏƁAFAT㔼ɂȂ󋵂ւ̑Ή
	if ( MAXFAT2 > MAXFAT ) MAXFAT2 = MAXFAT;	// 
	for ( ; i < MAXFAT2; i++ ) {				// 
		if ( fat[i].chain == FAT_FREE ) return i;
	}
	return -1;
}



//!///// Piece Kernel Service API Reference
//! 
//!  pceFileFindOpen
//! 
//! t@Ĉ߂̏܂B
//! 
//! int pceFileFindOpen(
//! 		FILEINFO *pfi		// FILEINFO \̂̃|C^
//! 		);
//! 
//! ߂lF 0 (I)
//! 
//! pfi̎\̂Jn̂߂ɏ܂B
//! Q : pceFileFindNext(), pceFileFindClose()
//!

int pceFileFindOpen( FILEINFO *pfi )
{
	WORKS *pw = (WORKS *)pfi->works;
	pw->pdir = msb->dir;
	return 0;
}

//!///// Piece Kernel Service API Reference
//! 
//!  pceFileFindNext
//! 
//! t@CʂԂ܂B
//! 
//! int pceFileFindNext(
//! 		FILEINFO *pfi		// FILEINFO \̂̃|C^
//! 		);
//! 
//! ߂l:
//!    0 : t@CȂ ( pfi ̃f[^͖ )
//!    1 : t@C ( pfi ̃f[^͗L )
//!
//!
//! ߂l 0 ɂȂ܂ŁAJԂĂяoĕ̃t@C𓾂܂B
//!
//! FILEINFO \̂̃o[
//!@
//! typedef struct tagFILEINFO {
//! 	char filename[MAXFILENAME+1]; // t@C
//! 	unsigned char attr;           //  (\ 0)
//! 	unsigned long length;         // 
//! 	unsigned long adrs;           // JnAhX (\ 0)
//! 	unsigned char works[16];      // Ɨ̈
//! } FILEINFO;
//!@
//!
//! \̂Q̃o[͌ݎgpĂ܂B
//! ǂ 0 Ԃ܂B
//!

int pceFileFindNext( FILEINFO *pfi )
{
	DIRECTORY *pdir = Search( (WORKS *)pfi->works );

	if ( pdir == NULL ) return 0;

	strncpy( pfi->filename, pdir->name, sizeof(pfi->filename) );
	pfi->length = pdir->size;
	pfi->attr = pdir->attr;
	pfi->adrs = 0;

	return 1;
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceFileFindClose
//! 
//! t@CI܂B
//! 
//! int pceFileFindClose(
//! 		FILEINFO *pfi		// FILEINFO \̂̃|C^
//! 		);
//! 
//! ߂lF 0 (I)
//! 
//! ǍIA[NJ܂B
//! ݂͉Ă܂񂪁A̔r̂߂
//! KĂяoĂB
//!

int pceFileFindClose( FILEINFO *pfi )
{
	return 0;
}



#define VALIDFILEACC 0x9ce6

//!///// Piece Kernel Service API Reference
//! 
//!  pceFileOpen
//! 
//! t@CI[v܂
//! 
//!	int pceFileOpen(
//! 		FILEACC *pfa,	// FILEACC \̂̃|C^
//! 		char *fname,	// t@C
//! 		int mode		// [h
//! 		);
//! 
//! ߂lF0 (I)
//!         1 (t@C)
//!
//! t@CANZX邷邽߂ɁAt@CI[v܂B
//! ƁApfa ̎\̂ɈȌ̃ANZX̂߂̏
//! i[܂B
//!
//! [h͈ȉ̐ݒ肪g܂B
//!@
//!   FOMD_RD [h
//!   FOMD_WR Cg
//!@
//!
//!  pceFileReadSct(), pceFileWriteSct(), pceFileClose() 
//! 킹ĂB
//!

int pceFileOpen( FILEACC *pfa, const char *fname, int mode )
{
	DIRECTORY *pdir = SearchFile( fname );

	pfa->valid = 0;

	if ( pdir == NULL ) return 1;	// no file

	pfa->fsize = pdir->size;
	pfa->chain = pdir->chain;
	pfa->valid = VALIDFILEACC;

	return 0;
}


static unsigned char *getpos( FILEACC *pfa, int sct )
{
	const SYSTEMINFO *sip = pceSystemGetInfo();
	int n = pfa->chain;

	while ( sct-- ) n = msb->fat[n].chain;

	return sip->pffs_top + BLOCKSIZE * n;
}


static int chkvalid( FILEACC *pfa )
{
	return pfa->valid == VALIDFILEACC;
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceFileReadSct
//! 
//! t@CPZN^Pʂœǂݍ݂܂B
//! 
//! int pceFileReadSct(
//! 		FILEACC *pfa,		// FILEACC \̂̃|C^
//! 		void *ptr,			// obt@̃|C^
//! 		int sct,			// t@C̃ZN^ԍ
//! 		int len				// (ő4096)
//! 		);
//! 
//! ߂lFǂݍ񂾃oCg
//!
//! PZN^4096oCgłB
//! ZN^ԍK؂łȂȂꍇ́Aǂݍ݂Ɏs 0 Ԃ܂B
//!
//! gdl ptr  NULL nƁAtbṼAhX
//! FILEACC \̂ aptr o[ɕԂAI܂B
//! ̏ꍇAʂȓ]IłB
//!
//! At@CVXe̕ύX CPŨԏɒڃ}bv
//! łȂ󋵂ꍇAVXeփobt@pӂA
//! ւ̃Rs[𔭐邱ƂőΉ\ƍlĂ܂B
//! Aobt@₻̗L̖蓙邽߁A
//! ɑ΂萫dȂAgpȂłB
//!

int pceFileReadSct( FILEACC *pfa, void *ptr, int sct, int len )
{
	const unsigned char *p;
	int len2;

	if ( !chkvalid(pfa) ) return 0;

	len2 = pfa->fsize - sct * BLOCKSIZE;

	if ( len2 <= 0 ) return 0;

	p = getpos( pfa, sct );

	if ( len > BLOCKSIZE ) len = BLOCKSIZE;
	if ( len > len2 ) len = len2;

	if ( !ptr ) {
		pfa->aptr = p;
	}
	else {
		memcpy( ptr, p, len );
	}

	return len;
}

//!///// Piece Kernel Service API Reference
//! 
//!  pceFileWriteSct
//! 
//! t@CɂPZN^Pʂŏ݂܂B
//! 
//! int pceFileWriteSct(
//! 		FILEACC *pfa,		// FILEACC \̂̃|C^
//! 		const void *ptr,	// obt@̃|C^
//! 		int sct,			// t@C̃ZN^ԍ
//! 		int len				// (ő4096)
//! 		);
//! 
//! ߂lF񂾃oCg
//!
//! PZN^4096oCgłB
//! ZN^ԍK؂łȂȂꍇ́A݂Ɏs 0 Ԃ܂B
//!

int pceFileWriteSct( FILEACC *pfa, const void *ptr, int sct, int len )
{
	unsigned char *p;
	int len2;

	if ( !chkvalid(pfa) ) return 0;

	len2 = pfa->fsize - sct * BLOCKSIZE;

	if ( len2 <= 0 ) return 0;

	p = getpos( pfa, sct );

	if ( len > BLOCKSIZE ) len = BLOCKSIZE;
	if ( len > len2 ) len = len2;

	pceFlashErase( p );
	pceFlashWrite( p, ptr, len );

	return len;
}

//!///// Piece Kernel Service API Reference
//! 
//!  pceFileClose
//! 
//! pceFileOpen ŃI[vt@CN[Y܂B
//! 
//! int pceFileClose(
//! 		FILEACC *pfa		// FILEACC \̂̃|C^
//! 		);
//! 
//! ߂lF0(ɐI)
//!
//! ݂͉Ă܂񂪁A̋@\ĝ
//! ANZXI͕KĂяoĂB
//!

int pceFileClose( FILEACC *pfa )
{
	if ( !chkvalid(pfa) ) return 1;

	pfa->valid = 0;

	return 0;
}



//!///// Piece Kernel Service API Reference
//! *v1.03
//! 
//!  pceFileCreate
//! 
//! t@CVɍ쐬܂B
//! ܂ɑ݂ꍇ́At@C̒ύX܂B
//! 
//! int pceFileCreate(
//! 		const char *fname,		// t@C
//! 		unsigned long size,		// t@C̒
//! 		);
//! 
//! ߂lF0 I
//!         0ȊO s 
//!
//! 4096oCg̃q[v̈悪mۂłȂꍇ͎s܂B
//!
//! VK쐬t@CTCY傫ȂꍇAV
//! ̈̃f[^e͕słBpceFileWriteSct() 
//! f[^łB
//!
//! ver1.14ȍ~ --->
//!
//! t@Cŋê͎̕łB
//!   '0'`'9'(), 'a'-'z'(p), '_'(A_[XRA)
//! ܂At@Cŋe钷
//!   O 1`8
//!   gqƂ '.'(sIh) Zp[^Ƃ
//!   gq 1`3
//! ƂȂ܂B <---
//!
//! G[̏ꍇ̖߂l̏ڍ
//!
//!  1 q[v̈悪mۂłȂ
//!  2 fBNgEGgs
//!  3 eʂs
//!  4 t@Cs
//!

int pceFileCreate( const char *fname, unsigned long size )
{
	DIRECTORY *pdir;
	pffsMASTERBLOCK *msbold, *pmb = pceHeapAlloc( 4096 );
	int err = 1;
	int sctcnt = ((size + 4095)>>12);
	int oldsctcnt = 0;

	msbold = msb;


	if ( !pmb ) return err;		// (1) Heap s

	if ( check_fname( fname ) ) {
		err = 4;				// (4) t@Cs
		goto _create_end;
	}

	memcpy( pmb, msbold, 4096 );

	msb = pmb;

	pdir = SearchFile( fname );

	if ( !pdir ) {
		int i;
		pdir = pmb->dir;
		for ( i = 0; i < MAXDIR; i++ ) {
			if ( pdir->name[0] == -1 ) goto _create_next;
			pdir++;
		}
		err = 2;				// (2) fBNgEGgs
		goto _create_end;

_create_next:
		memset( pdir, 0, sizeof(*pdir) );
		strncpy( pdir->name, fname, sizeof(pdir->name)-1 );
		pdir->chain = FAT_FREE;
	}
	else {
		oldsctcnt = ((pdir->size + 4095)>>12);
		if ( size == pdir->size ) {
			err = 0;			// TCY̏ꍇ͉Ȃ
			goto _create_end;
		}
	}

	pdir->size = size;

	{
		unsigned short *ps = &pdir->chain;
		FAT *fat = pmb->fat;
		int i;
		int nn = 0;

		for ( i = 0; i < sctcnt; i++ ) {
			int n = *ps;
			if ( n == FAT_FREE || n == FAT_END ) {
				n = FATAlloc( fat, nn );
				if ( n < 0 ) {
					err = 3;		// (3) eʕs
					goto _create_end;
				}
				*ps = n;
				nn = n+1;
			}
			ps = &fat[n].chain;
		}

		nn = *ps;
		*ps = FAT_END;

		for ( ; i < oldsctcnt; i++ ) {
			ps = &pmb->fat[nn].chain;
			nn = *ps;
			*ps = FAT_FREE;
			if ( nn == FAT_FREE || nn == FAT_END ) break;
		}
	}

	pceFlashErase( msbold );
	pceFlashWrite( msbold, pmb, 4096 );

	err = 0;

_create_end:
	msb = msbold;
	pceHeapFree( pmb );

	return err;
}



//!///// Piece Kernel Service API Reference
//! *v1.03
//! 
//!  pceFileDelete
//! 
//! t@C폜܂B
//! 
//! int pceFileDelete(
//! 		const char *fname,		// t@C
//! 		);
//! 
//! ߂lF0 I
//!         0ȊO s 
//!
//! 4096oCg̃q[v̈悪mۂłȂꍇ͎s܂B
//!
//! G[̏ꍇ̖߂l̏ڍ
//!
//!  1 q[v̈悪mۂłȂ
//!  2 t@C݂Ȃ
//!

int pceFileDelete( const char *fname )
{
	DIRECTORY *pdir;
	pffsMASTERBLOCK *msbold, *pmb = pceHeapAlloc( 4096 );
	int err = 1;

	msbold = msb;
	
	if ( !pmb ) return err;		// (1) Heap s

	memcpy( pmb, msbold, 4096 );

	msb = pmb;

	pdir = SearchFile( fname );

	if ( !pdir ) {
		err = 2;				// (2) t@C݂Ȃ
		goto _delete_end;
	}

	{
		int c = pdir->chain;

		while ( c != FAT_END ) {
			int n = pmb->fat[c].chain;
			pmb->fat[c].chain = FAT_FREE;
			c = n;
		}
	}

	memset( pdir, 0xff, sizeof(*pdir) );

	pceFlashErase( msbold );
	pceFlashWrite( msbold, pmb, 4096 );

	err = 0;

_delete_end:
	msb = msbold;
	pceHeapFree( pmb );

	return err;
}



int pceFileRename( const char *fnameold, const char *fnamenew )
{
	DIRECTORY *pdir;
	pffsMASTERBLOCK *msbold, *pmb = pceHeapAlloc( 4096 );
	int err = 1;

	msbold = msb;
	
	if ( !pmb ) return err;		// (1) Heap s

	memcpy( pmb, msbold, 4096 );

	msb = pmb;

	pdir = SearchFile( fnameold );

	if ( !pdir ) {
		err = 2;				// (2) t@C݂Ȃ
		goto _rename_end;
	}

	strncpy( pdir->name, fnamenew, sizeof(pdir->name)-1 );

	pceFlashErase( msbold );
	pceFlashWrite( msbold, pmb, 4096 );

	err = 0;

_rename_end:
	msb = msbold;
	pceHeapFree( pmb );

	return err;
}



#define EOF (-1)


static int getnextsect( zlibIO *pzi )
{
	unsigned long len;

	if ( !wklen ) return EOF;

	len = wklen;
	if ( len > BLOCKSIZE ) len = BLOCKSIZE;

	wklen -= len;

	pceFileReadSct( &facc, NULL, bpos++, len );

	pzi->ptr = (unsigned char *)facc.aptr;
	pzi->ptre = pzi->ptr + len;

	return *pzi->ptr++;
}


static void pceBlockCopy( zlibIO *zlIn, zlibIO *zlOut )
{
	while ( 1 ) {
		int a;
		unsigned long c = wkin.ptre - wkin.ptr;
		memcpy( wkout.ptr, wkin.ptr, c );
		wkout.ptr += c;
		a = getnextsect( &wkin );
		if ( a == EOF ) break;
		*wkout.ptr++ = a;
	}
}

static void dummy_flush( zlibIO *pzio )
{
}

int pceFileLoad( const char *name, void *ptr )
{
	const SYSTEMINFO *sip = pceSystemGetInfo();
	unsigned long len;
	int type = 0;

	if ( pceFileOpen( &facc, name, FOMD_RD ) ) return -1;

	len = pceFileReadSct( &facc, NULL, 0, BLOCKSIZE );

	wkin.ptr = (unsigned char *)facc.aptr;
	wklen = facc.fsize;

	// load
	if ( !ptr ) {
		pffsFileHEADER *pfh = (pffsFileHEADER *)facc.aptr;
		if ( pfh->mark != 'X' ) return 3; // s`łȂ
		ptr = (void *)pfh->top_adrs;
		wklen = pfh->length;
		wkin.ptr += pfh->ofs_data;
		len -= pfh->ofs_data;
		type = pfh->type;
	}

	wkout.ptr0 = ptr;
	wkout.ptr = ptr;
	wkout.ptre = sip->sram_end;
	wkout.fn.fls = dummy_flush;

	wkin.ptre = wkin.ptr + len;
	wkin.fn.fil = getnextsect;

	bpos = 1;

	switch ( type ) {
		case PFFS_FT_EXE2:
			{
				unsigned long *a = (unsigned long *)wkin.ptr;
				void *tmpbuf = pceHeapAlloc( 0x2000-32 );
				if ( !tmpbuf ) APIErr(0,PCEKN_ERR_NOHEAP);
				wkin.ptr += 8;
				pceZlibExpand( &wkin, &wkout, tmpbuf );
				pceHeapFree( tmpbuf );
				pceCRC32( 0, 0 );
				if ( a[0] != wkout.ptr - wkout.ptr0 ) return 1; // WJG[
				if ( pceCRC32( wkout.ptr0, a[0] ) != a[1] ) return 2; // CRCG[
			}
			break;
		default:
			pceBlockCopy( &wkin, &wkout );
			break;
	}

	return 0;
}

//2004/05/03 Add by Madoka
static int mmc_getnextsect( zlibIO *pzi )
{
	unsigned long len;

	if ( !wklen ) return EOF;

	len = wklen;
	if ( len > BLOCKSIZE ) len = BLOCKSIZE;

	wklen -= len;

	mmcFileReadSct( &facc, NULL, bpos++, len );

	pzi->ptr = (unsigned char *)facc.aptr;
	pzi->ptre = pzi->ptr + len;

	return *pzi->ptr++;
}
//---------------------------------------------------------------------------
static void mmcBlockCopy( zlibIO *zlIn, zlibIO *zlOut )
{
	while ( 1 ) {
		int a;
		unsigned long c = wkin.ptre - wkin.ptr;
		memcpy( wkout.ptr, wkin.ptr, c );
		wkout.ptr += c;
		a = mmc_getnextsect( &wkin );
		if ( a == EOF ) break;
		*wkout.ptr++ = a;
	}
}
//---------------------------------------------------------------------------
int mmcFileLoad( const char *name)
{

	//pext@C[h
	//߂l
	// 0:I
	// 1:WJG[
	// 2:CRCG[
	// 3:s`ł͂Ȃ
	//-1:t@CI[vG[
	//-2:MMCG[

	const SYSTEMINFO *sip = pceSystemGetInfo();
	unsigned long len;
	int type = 0;
	void *ptr = NULL;
	int iRet = 0;
#define PEX_FILESIZE_MAX	(256)	//MMCŋNłpext@C̍őTCY(KB) 

	//MMC̏
	if(mmcInit(PEX_FILESIZE_MAX * 1024) == 0)
	{
		//s
		iRet = -2;
		goto mmcFileLoadEnd;
	}
	
	if ( mmcFileOpen( &facc, name, FOMD_RD ) )
	{
		//t@CI[vs
		iRet = -1;
		goto mmcFileLoadEnd;
	}
		
	len = mmcFileReadSct( &facc, NULL, 0, BLOCKSIZE );
	
	wkin.ptr = (unsigned char *)facc.aptr;
	wklen = facc.fsize;

	// load
	{
		pffsFileHEADER *pfh = (pffsFileHEADER *)facc.aptr;
		if ( pfh->mark != 'X' )
		{
			// s`łȂ
			iRet = 3;
			goto mmcFileLoadEnd;
		}
		ptr = (void *)pfh->top_adrs;
		wklen = pfh->length;
		wkin.ptr += pfh->ofs_data;
		len -= pfh->ofs_data;
		type = pfh->type;
	}

//fobOpɎgĂ܂(^^;
#if 0
	{
		//ǂݍ񂾓e"test.bin"ƂătbV
		//o܂
		FILEACC tAcc;
		pceFileCreate("test.bin",BLOCKSIZE);
		pceFileOpen(&tAcc,"test.bin",FOMD_WR);
		if(pceFileWriteSct(&tAcc,facc.aptr,0,BLOCKSIZE) == 0)
			APIErr(0,888);	//KȃG[\
		pceFileClose(&tAcc);
		iRet = 3;
		goto mmcFileLoadEnd;
	}
#endif

	wkout.ptr0 = ptr;
	wkout.ptr = ptr;
	wkout.ptre = sip->sram_end;
	wkout.fn.fls = dummy_flush;

	wkin.ptre = wkin.ptr + len;
	wkin.fn.fil = mmc_getnextsect;

	bpos = 1;

	switch ( type ) {
		case PFFS_FT_EXE2:
			{
				//unsigned long *a = (unsigned long *)wkin.ptr;
				void *tmpbuf = pceHeapAlloc( 0x2000-32 );
				if ( !tmpbuf ) APIErr(0,PCEKN_ERR_NOHEAP);
				
				wkin.ptr += 8;
				pceZlibExpand( &wkin, &wkout, tmpbuf );
				pceHeapFree( tmpbuf );
				
				//MMC̃f[^ׂ͂đփobt@Ɋi[A
				//WJɂ͏㏑Bwkout.ptrփobt@
				//̃AhXȂ̂Ł̓WJ`FbNCRCG[
				//̓`FbNł܂B̂ƂĐi߂܂B
	
				//`FbNłȂ̂ŃRg
				//pceCRC32( 0, 0 );
				//if ( a[0] != wkout.ptr - wkout.ptr0 ) return 1; // WJG[
				//if ( pceCRC32( wkout.ptr0, a[0] ) != a[1] ) return 2; // CRCG[
			}
			break;
		default:
			mmcBlockCopy( &wkin, &wkout );
			break;
	}

mmcFileLoadEnd:
	
	//MMC̏I
	mmcExit();

	return 0;

}
//---------------------------------------------------------------------------


int pceZlibExpand2( void *inbf, void *outbf, int outbfsiz )
{
	return 0;
}


static void SearchMasterBlock( void )
{
	const SYSTEMINFO *sip = pceSystemGetInfo();
	msb = (pffsMASTERBLOCK *)sip->pffs_top;
}

void InitFile( void )
{
	SearchMasterBlock();

	pceVectorSetKs( KSNO_FileFindOpen, pceFileFindOpen );
	pceVectorSetKs( KSNO_FileFindNext, pceFileFindNext );
	pceVectorSetKs( KSNO_FileFindClose, pceFileFindClose );
	pceVectorSetKs( KSNO_FileLoad, pceFileLoad );
	pceVectorSetKs( KSNO_FileOpen, pceFileOpen );
	pceVectorSetKs( KSNO_FileReadSct, pceFileReadSct );
	pceVectorSetKs( KSNO_FileWriteSct, pceFileWriteSct );
	pceVectorSetKs( KSNO_FileClose, pceFileClose );
	pceVectorSetKs( KSNO_FileCreate, pceFileCreate );
	pceVectorSetKs( KSNO_FileDelete, pceFileDelete );
}



