
#include <piece.h>
#include "pcekn.h"

#define D12_COMMAND 0x400004
#define D12_DATA 0x400000

#define USEDMA 0


void D12OutCmd( unsigned char dt )
{
	*(unsigned char *)D12_COMMAND = dt;
}

void D12OutDat( unsigned char dt )
{
	*(unsigned char *)D12_DATA = dt;
}

unsigned char D12InDat( void )
{
	return *(unsigned char *)D12_DATA;
}


#if USEDMA==0
void D12InDatN( unsigned char *p, unsigned len )
{
	do {
		*p++ = *(unsigned char *)D12_DATA;
	} while ( --len );
}

void D12OutDatN( unsigned char *p, unsigned len )
{
	do {
		*(unsigned char *)D12_DATA = *p++;
	} while ( --len );
}
#else
//
// cOł USB  DMA ŗLɎĝ͖Ȃ悤łB
//
void D12InDatN( unsigned char *p, unsigned len )
{
	volatile unsigned char *bp = iop_c;
	volatile unsigned short *sp = iop_s;
	volatile unsigned long *wp = iop_w;
	static char sf;

	while ( sp[0x824c/2] & 1 );

	ENTER_CS;

	if ( !sf ) {
	sf=1;

	// for 8bit timer
	bp[0x168] = 0;		// 8bit^C}ch2 
	bp[0x146] |= 0x04;	// 8bit^C}ch2 NbNI 
	bp[0x14e] |= 0x08;	// 8bit^C}ch2 NbN on
	bp[0x169] = 12-1;	// 8bit^C}ch2 [hl
	bp[0x168] = 3;		// 8bit^C}ch2 

	// for HSDMA
	bp[0x299] &= 0xf0;
	bp[0x299] |= 0x05;	// HSDMA Ch2 gKݒ (8bit^C}ch2 uf)
	}

	wp[0x8240/4] = len|0x80000000;			// HSDMA Ch2 ]JEg
	wp[0x8244/4] = D12_DATA;				// HSDMA Ch2 ]AhX
	wp[0x8248/4] = ((int)p)|0x30000000;		// HSDMA Ch2 ]AhX

	sp[0x824e/2] = 1;		// HSDMA Ch0 gKtONA
	sp[0x824c/2] = 1;		// HSDMA Ch0 Cl[u

	while ( sp[0x824c/2] & 1 );

	LEAVE_CS;

}
#endif


