
/////////////////////////////////////////////////////////////////////////////
//
//             /
//      -  P  /  E  C  E  -
//           /                 mobile equipment
//
//              System Programs
//
//
// PIECE KERNEL : Ver 1.19
//
// Copyright (C)2001 AUQAPLUS Co., Ltd. / OeRSTED, Inc. all rights reserved.
//
// Coded by MIO.H (OeRSTED)
//
// Comments:
//
//  tbV̗eʌo[`łB
//
//  v1.19 2003.02.25 N.SAWA VK쐬
//



#include <piece.h>
#include "pcekn.h"


#define CFIINFO_OFFSET	0x10		/* CFING[̐擪ItZbgin[t[hPʁIj */
typedef struct _CFIINFO {
	/* CFI Query Identification String */
	unsigned short query_unique_ascii_string[3];							/* 10-12 */
	unsigned short primary_oem_command_set[2];								/* 13-14 */
	unsigned short address_for_primary_extended_table[2];					/* 15-16 */
	unsigned short alternate_oem_command_set[2];							/* 17-18 */
	unsigned short address_for_alternate_oem_extended_table[2];				/* 19-1a */
	/* System Interface Information */
	unsigned short vdd_min;													/* 1b */
	unsigned short vdd_max;													/* 1c */
	unsigned short vpp_min;													/* 1d */
	unsigned short vpp_max;													/* 1e */
	unsigned short typical_time_out_for_word_program;						/* 1f */
	unsigned short typical_time_out_for_min_size_buffer_program;			/* 20 */
	unsigned short typical_time_out_for_individual_sector_block_erase;		/* 21 */
	unsigned short typical_time_out_for_chip_erase;							/* 22 */
	unsigned short maximum_time_out_for_word_program;						/* 23 */
	unsigned short maximum_time_out_for_buffer_program;						/* 24 */
	unsigned short maximum_time_out_for_individual_sector_block_erase;		/* 25 */
	unsigned short maximum_time_out_for_chip_erase;							/* 26 */
	/* Device Geometry Information */
	unsigned short device_size;												/* 27 */
	unsigned short flash_device_interface_description[2];					/* 28-29 */
	unsigned short maximum_number_of_byte_in_multi_byte_write[2];			/* 2a-2b */
	unsigned short number_of_erase_sector_block_sizes_supported_by_device;	/* 2c */
	unsigned short sector_information[4];									/* 2d-30 */
	unsigned short block_information[4];									/* 31-34 */
} CFIINFO;


/* ̊֐́ARAM܂SRAMɒuĎsĂBtbV͂߁I
 * ̊֐ĂԑOɁA荞݁ENMISĒ~ĂĂB
 */
int subFlashSize( void )
{
	volatile unsigned short *c1p = (unsigned short *)(0xc00000 + 0x5555*2);
	volatile unsigned short *c2p = (unsigned short *)(0xc00000 + 0x2aaa*2);
	volatile CFIINFO* cfi = (CFIINFO*)(0xc00000 + CFIINFO_OFFSET*2);
	short device_size;

	// CFING[[hɓ܂B
	*c1p = 0xaa;
	*c2p = 0x55;
	*c1p = 0x98;

	pdwait(5);	// 150[ns]ȏ

	// eʁi=(1<<device_size)[oCg]j擾B
	device_size = cfi->device_size;

	// CFING[[h𔲂܂B
	*c1p = 0xaa;
	*c2p = 0x55;
	*c1p = 0xf0;

	pdwait(5);	// 150[ns]ȏ

	return 1 << device_size;
}



