
/////////////////////////////////////////////////////////////////////////////
//
//             /
//      -  P  /  E  C  E  -
//           /                 mobile equipment
//
//              System Programs
//
//
// PIECE KERNEL : Ver 1.00
//
// Copyright (C)2001 AUQAPLUS Co., Ltd. / OeRSTED, Inc. all rights reserved.
//
// Coded by MIO.H (OeRSTED)
//
// Comments:
//
//  tHghCołB
//
//  v1.00 2001.11.09 MIO.H
//  v1.01 2001.11.10 MIO.H  4x6hbgtHg̓
//  v1.20 2004.05.09 Madoka MMCpAPIǉɂACodeZNV̗̈悪
//                          tHgzuĂ0xC0C000𒴂Ă܂
//                          ̂ŁAtHgf[^̂AhXύX܂B
//  v1.24 2004.10.26 Madoka tHgf[^̃AhXύX
//                          nsawa(http://piece.no-ip.org/)
//                          ύXȅڍׂ͂灨http://piece.no-ip.org/mmc123-20041026.html
//

#include <piece.h>
#include <vector.h>
#include <work.h>

#define XMAX  128	// Sʕ\
#define YMAX  88	// Sʕ\

//2004/05/09 Add by Madoka
#define	FONT_NORMAL_ADDRESS	(0xC0D000)	//ʏtHg̃AhX
#define FONT_BIG_ADDRESS    (0xC27000)  //gtHg̃AhX  2004/10/25 Ĕzu
#define FONT_SMALL_ADDRESS  (0xC27600)  //ɏtHg̃AhX  2004/10/25 Ĕzu
//etHg̃AhX́Apcekn.mapCodeZNV̏Ïʒu
//KɌ߂ĂB
//tHg̔zuAhX߂A..\..\update\makefile̓e
//ύXĂB

static unsigned char XMAX2;	// Xs|Cg

typedef struct _KFONTHDR {
	unsigned short ofs;
	unsigned char s;
	unsigned char e;
} KFONTHDR;

static const unsigned char __nofont[] = {
	0x55,0x55,0x55, 0x55,0x55,0x55, 0x55,0x55,0x55,
	0x55,0x55,0x55, 0x55,0x55,0x55, 0x55,0x55,0x55,
};

#define NOFONT ((unsigned char *)__nofont)

//!///// Piece Kernel Service API Reference
//! 
//!  pceFontGetAdrs
//! 
//! tHg̃AhX擾܂B
//! 
//! const unsigned char *pceFontGetAdrs(
//! 		unsigned short code			// R[h
//! 		);
//! 
//! ߂lFtHg̃AhX
//!         AhXb311̏ꍇ͔ptHgł邱Ƃ܂B
//!
//! R[h͈ȉ͈̔͂łB
//!
//!       0x20 - 0x7f : ASCII
//!       0xa0 - 0xdf : pJi
//!       0x8140 - 0xfcfc : 
//!
static const unsigned char *_pceFontGetAdrs( unsigned short code )
{
	unsigned char h = code>>8;
	unsigned char l = code;
	KFONTHDR *hp;

	if ( h >= 0x81 && h <= 0x9f ) {
		h-=0x81;
	}
	else if ( h >= 0xe0 && h <= 0xfc ) {
		h-=(0x81+0x40);
	}
	else if ( h == 0 ) {	// p
		if ( l >= 0x20 && l <= 0x7f ) {
			return (unsigned char *)(0x80000000 + fnt_hp + (l-0x20)*fnt_hb);
		}
		else if ( l >= 0xa0 && l <= 0xdf ) {
			return (unsigned char *)(0x80000000 + fnt_hp + (l-0x40)*fnt_hb);
		}
		return NOFONT+0x80000000;
	}
	else {
		return NOFONT;
	}

	h<<=1;
	if ( l >= 0x80 ) l--;
	l-=0x40;
	if ( l >= 94 ) { l-=94; h++; }

	if ( h >= fnt_zc || l >= 94 ) return NOFONT;

	hp = ((KFONTHDR *)fnt_zp) + h;

	if ( l < hp->s || l > hp->e ) return NOFONT;

	return (unsigned char *)(fnt_zp + sizeof(*hp)*fnt_zc + (hp->ofs-hp->s+l)*fnt_zb);
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceFontPut
//! 
//! tHgzʂɕ\܂B
//!
//! unsigned short pceFontPut(
//! 		int x,			 	// xW
//! 		int y,				// yW
//! 		unsigned short code	// R[h
//!			);
//!
//! ߂lFb0-7   x̕
//!         b8-15  y̕
//!
//! gpł镶R[h pceFontGetAdrs() B
//!
//! zʂ͈̔͊O̓NbsO܂B
//! 
//!

#define FC_SPRITE2 255

unsigned short pceFontPut( int x, int y, unsigned short code )
{
	const unsigned char *p = pceFontGetAdrs( code );
	unsigned char *q = pceLCDSetBuffer(INVALIDPTR)+(y<<7);
	unsigned char txc = fnt_txc;
	unsigned char bkc = fnt_bkc;
	int ye = y + fnt_dt;

	if ( (int)p & 0x80000000 ) {
		int xe = x + fnt_dth;
		if ( ye > YMAX || y < 0 || xe > XMAX || x < 0 ) {
			for ( ; y < ye; y++ ) {
				unsigned long a = *p++;
				if ( y >= 0 && y < YMAX ) {
					if ( bkc == FC_SPRITE2 ) {
						for ( ; x < xe; x++ ) {
							if ( x >= 0 && x < XMAX && a & 0x80 ) q[x] = txc;
							a<<=1;
						}
					}
					else {
						for ( ; x < xe; x++ ) {
							if ( x >= 0 && x < XMAX ) q[x] = ( a & 0x80 ) ? txc : bkc;
							a<<=1;
						}
					}
					x -= fnt_dth;
				}
				q+=128;
			}
		}
		else {
			for ( ; y < ye; y++ ) {
				unsigned long a = *p++;
				if ( bkc == FC_SPRITE2 ) {
					for ( ; x < xe; x++ ) {
						if ( a & 0x80 ) q[x] = txc;
						a<<=1;
					}
				}
				else {
					for ( ; x < xe; x++ ) {
						q[x] = ( a & 0x80 ) ? txc : bkc;
						a<<=1;
					}
				}
				x -= fnt_dth;
				q+=128;
			}
		}
		return (fnt_dt<<8)+fnt_dth;
	}
	else {
		int xe = x + fnt_dt;
		if ( ye > YMAX || y < 0 || xe > XMAX || x < 0 ) {
			for ( ; y < ye; y+=2 ) {
				unsigned long a = (((p[0]<<8)+p[1])<<8)+p[2];
				int f0 = (y >= 0 && y < YMAX);
				int f1 = (y+1 >= 0 && y+1 < YMAX);
				if ( bkc == FC_SPRITE2 ) {
					for ( ; x < xe; x++ ) {
						if ( x >= 0 && x < XMAX ) {
							if ( f0 && (a & 0x800000) ) q[x+0] = txc;
							if ( f1 && (a &    0x800) ) q[x+128] = txc;
						}
						a<<=1;
					}
				}
				else {
					for ( ; x < xe; x++ ) {
						if ( x >= 0 && x < XMAX ) {
							if ( f0 ) q[x+0]   = ( a & 0x800000 ) ? txc : bkc;
							if ( f1 ) q[x+128] = ( a &    0x800 ) ? txc : bkc;
						}
						a<<=1;
					}
				}
				x -= fnt_dt;
				p+=3;
				q+=128*2;
			}
		}
		else {
			for ( ; y < ye; y+=2 ) {
				unsigned long a = (((p[0]<<8)+p[1])<<8)+p[2];
				if ( bkc == FC_SPRITE2 ) {
					for ( ; x < xe; x++ ) {
						if ( a & 0x800000 ) q[x+0] = txc;
						if ( a &    0x800 ) q[x+128] = txc;
						a<<=1;
					}
				}
				else {
					for ( ; x < xe; x++ ) {
						q[x+0]   = ( a & 0x800000 ) ? txc : bkc;
						q[x+128] = ( a &    0x800 ) ? txc : bkc;
						a<<=1;
					}
				}
				x -= fnt_dt;
				p+=3;
				q+=128*2;
			}
		}
		return (fnt_dt<<8)+fnt_dt;
	}
}




//!///// Piece Kernel Service API Reference
//! 
//!  pceFontSetType
//! 
//! tHg̎ނ\w肵܂B
//!
//! void pceFontSetType(
//!			int type		// tHg̎ށE\
//!			);
//!
//! ߂lFȂ
//!
//!  tHg̎ނƎs̗Lw肵܂B
//!
//! bit0`6 : tHg̎
//!   0 ʏtHg p5~10hbg Sp10~10hbg
//!   1 gtHg p8~16hbg {[h (ASCIÎ)
//!   2 ɏtHg p4~ 6hbg (ASCIÎ)
//!
//! bit7 :
//!   0 ̎́AʉE[Ŏs
//!   1 ̎́AsȂ
//!
//! m̃oO
//!  bit7  1 łAʊỎEɑʂ̕\ƉsĂ܂܂B
//!
//!
static void _pceFontSetType( int type )
{
	int n;

	fnt_typ = type;

	XMAX2 = ( type & 0x80 ) ? 255 : 120;

	type &= 0x7f;

	if ( !type ) {
		//fnt_hp = (unsigned char *)0xc0c000;	
		fnt_hp = (unsigned char *)FONT_NORMAL_ADDRESS;	//2004/05/09 by Madoka	
		n = 10;

		fnt_dt  = n;
		fnt_dth = n/2;
		fnt_hb  = n;
		fnt_zb  = n + (n>>1);
		fnt_zp  = fnt_hp + fnt_hb * 160;
		fnt_zc  = 84;
	}
	else if ( type == 1 ) {
		//fnt_hp = (unsigned char *)0xc26000;
		fnt_hp = (unsigned char *)FONT_BIG_ADDRESS;		//2004/05/09 by Madoka			
		n = 16;

		fnt_dt  = n;
		fnt_dth = n/2;
		fnt_hb  = n;
		fnt_zb  = 0;
		fnt_zp  = NULL;
		fnt_zc  = 0;
	}
	else {
		//fnt_hp = (unsigned char *)0xc27000;
		fnt_hp = (unsigned char *)FONT_SMALL_ADDRESS;	//2004/05/09 by Madoka
		n = 6;

		fnt_dt  = 6;
		fnt_dth = 4;
		fnt_hb  = 6;
		fnt_zb  = 0;
		fnt_zp  = NULL;
		fnt_zc  = 0;
	}
}

//!///// Piece Kernel Service API Reference
//! 
//!  pceFontSetTxColor
//! 
//! ̐Fw肵܂B
//!
//! void pceFontSetTxColor(
//!			int color		// F(0`3)
//!			);
//!
//! ߂lFȂ
//!
void _pceFontSetTxColor( int color )
{
	fnt_txc = color;
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceFontSetBkColor
//! 
//! ̔wiFw肵܂B
//!
//! void pceFontSetBkColor(
//!			int color		// wiF
//!			);
//!
//! ߂lFȂ
//!
//! color : wiF(0`3) , FC_SPRITE(=-1)̏ꍇ͓
//!
//!
void _pceFontSetBkColor( int color )
{
	fnt_bkc = color;
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceFontPutStr
//! 
//! zʂɏ݂܂B
//!
//! int pceFontPutStr(
//!			const char *p		// ̃AhXB0 ŏI[B
//!			);
//!
//! ߂lFŌ̂PoCgVtgJIS̑PoCgꍇ
//!         R[hԂ܂B̑̏ꍇ 0 łB
//!
//! W̓VXeŕێĂWłB\ɂK؂Ɉړ܂B
//! ܂ pceFontSetPos() Ŏw肷邱Ƃ\łB
//!
//! ʂ̒[ł͓K؂ɃNbsO܂B܂ʊOł͕\܂B
//!
int pceFontPutStr( const char *p )
{
	union {
		unsigned short s;
		struct {
			unsigned char w;
			unsigned char h;
		} b;
	} m;
	unsigned char c1;
	int x = DispX;
	int y = DispY;

	m.s = 0;

	while ( 1 ) {
		c1 = *p++;
		if ( !c1 ) break;
		if ( (c1>=0x81 && c1<=0x9f) || (c1>=0xe0 && c1<=0xfc) ) {
			if ( *p ) {
				unsigned char c2 = *p++;
				m.s = pceFontPut( x, y, (c1<<8) + c2 );
			}
			else {
				break;
			}
			x += m.b.w;
		}
		else if ( c1 == '\n' ) {
			goto CRLF;
		}
		else {
			m.s = pceFontPut( x, y, c1 );
			x += m.b.w;
		}
		if ( x >= XMAX2 ) {
CRLF:
			x = 0;
			y += fnt_dt; //m.b.h;
		}
	}

	DispX = x;
	DispY = y;

	return c1;
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceFontSetPos
//! 
//! \Ww肵܂B
//! 
//! void pceFontSetPos(
//!			int x,
//!			int y
//!			);
//!
//! int x : xW
//! int y : yW
//!
//! ߂lFȂ
//!
//! pceFontPutStr(), pceFontPrintf() ł̍Ww肵܂B
//!
void pceFontSetPos( int x, int y )
{
	DispX = x;
	DispY = y;
}





void PushFontParameters( void )
{
	save_DispX = DispX;
	save_DispY = DispY;
	save_fnt_txc = fnt_txc;
	save_fnt_bkc = fnt_bkc;
	save_fnt_typ = fnt_typ;
}


void PopFontParameters( void )
{
	DispX = save_DispX;
	DispY = save_DispY;
	fnt_txc = save_fnt_txc;
	fnt_bkc = save_fnt_bkc;
	_pceFontSetType( save_fnt_typ );
}




void InitFont( void )
{
	_pceFontSetType(0);
	_pceFontSetTxColor(3);
	_pceFontSetBkColor(0);
	pceVectorSetKs( KSNO_FontGetAdrs, _pceFontGetAdrs );
	pceVectorSetKs( KSNO_FontPut, pceFontPut );
	pceVectorSetKs( KSNO_FontSetType, _pceFontSetType );
	pceVectorSetKs( KSNO_FontSetTxColor, _pceFontSetTxColor );
	pceVectorSetKs( KSNO_FontSetBkColor, _pceFontSetBkColor );
	pceVectorSetKs( KSNO_FontSetPos, pceFontSetPos );
	pceVectorSetKs( KSNO_FontPutStr, pceFontPutStr );
	pceVectorSetKs( KSNO_FontPrintf, pceFontPrintf );
	pceVectorSetKs( KSNO_sprintf, pcesprintf );
	pceVectorSetKs( KSNO_vsprintf, pcevsprintf );
}




