
/////////////////////////////////////////////////////////////////////////////
//
//             /
//      -  P  /  E  C  E  -
//           /                 mobile equipment
//
//              System Programs
//
//
// PIECE KERNEL : Ver 1.10
//
// Copyright (C)2001 AUQAPLUS Co., Ltd. / OeRSTED, Inc. all rights reserved.
//
// Coded by MIO.H (OeRSTED)
//
// Comments:
//
//  LCD hCołB
//
//  v1.00 2001.11.09 MIO.H
//  v1.05 2001.11.21 MIO.H	lcdwk ߑł
//  v1.11 2001.12.03 MIO.H	pceLCDSetOrientation  pceLCDTrans Ȃ悤
//  v1.16 2002.01.05 MIO.H	ɑSŖ߂ ` disp()
//  v1.19 2003.02.14 N.SAWA	asm("mirror")̃WX^ߑłAgasm\ɕύX
//  v1.19 2003.02.15 N.SAWA	tZx΂Ĉ߁A\tgZbgn[hZbgɕύX
//  v1.19 2003.02.16 N.SAWA	CSBM(P20)͏グςȂ(0Œ)ővƎv܂
//  v1.19 2003.02.24 N.SAWA	AvP[VCSBꍇ̑΍ƂāATxLCDAsync()CSBグ
//							n[hZbgAZbgỎʕ\ON/OFF𕜌悤ɕύX
//



#include <piece.h>
#include <string.h>
#include "pcekn.h"


#define BL1 45 // Z1 ( 0 ` 32() ` 63 Z)
#define BL2 6  // Z2 ( 0 ` 7 Z)
#define BL3 5


void pdwait( int n );

#define NEWLCD
//#define REVUD
#define USEDMA

// powerman.c
//void DispBattStat( void );       //change 10/29
void MakeBattStat(char *powstr);
void DispBattStatns(int loc,char *ptr,char *powstr);

typedef struct tagLCDWK {
	unsigned char *buffp;
	signed short cnt;
	//signed short resv1;		// 2003.02.24 N.SAWA LCD\ԕۑ̂߁A2oCg1oCg𗘗p
	unsigned char display_on;	//            n[hZbĝ̕߂ɁALCDON/OFFԂۑ
	unsigned char resv1;		//            i\j
	unsigned char txbuff[256+8];
} LCDWK;

static LCDWK lcdwk;

//static unsigned char *dma_p;
//static unsigned char dma_n;

static void TxLCDAsync( const unsigned char *p, int len, unsigned char s1 )
{
	volatile unsigned char *bp = iop_c;
	volatile unsigned short *sp = (volatile unsigned short *)bp;

	bp[0x1f8] = 0x00;	// VA ch3 
	//bp[0x2d9] |= 0x01;			// !CS 2003.02.16 N.SAWA 폜܂

	if ( s1 ) bp[0x2d9] |= 0x02; else bp[0x2d9] &= ~0x02;

	if ( len > 1 ) {
		volatile unsigned long *wp = (volatile unsigned long *)bp;

		wp[0x8220/4] = (len-1)|0x80000000;			// HSDMA Ch0 ]JEg
		wp[0x8224/4] = ((int)p+1)|0x30000000;		// HSDMA Ch0 ]AhX
		wp[0x8228/4] = 0x401f5;						// HSDMA Ch0 ]AhX

		sp[0x822e/2] = 1;		// HSDMA Ch0 gK
		sp[0x822c/2] = 1;		// HSDMA Ch0 Cl[u
	}

	bp[0x2d9] &= ~0x01;			// CS 2003.02.24 N.SAWA {ICS͏グςȂȂ̂ŏグ͕svłA
								//                      AAvP[V牺ꂽꍇɔāA
								//                      ]ÔꂩcĂƂɂ܂B
	bp[0x1f5] = p[0];

	bp[0x1f8] = 0x80;	// VA ch3 
}

#if 0
//static void TxLCDAsyncDone( void )
//{
//	INT_BEGIN;
//	{
//		volatile unsigned char *bp = iop_c;
//
//		bp[0x281] &= ~0x01;		// DMA 荞݃NA (HSDMA Ch0̂)
//		bp[0x271] &= ~0x01;		// DMA 荞݋֎~ (HSDMA Ch0̂)
//	}
//	INT_END;
//}
#endif

static void TxLCD( const unsigned char *p, int len, unsigned char s1 )
{
	volatile unsigned char *bp = iop_c;
	volatile unsigned short *sp = (volatile unsigned short *)bp;

	while ( sp[0x822c/2] & 1 ) pdwait(5);
	while ( bp[0x1f7] & 0x20 ) pdwait(5);
#if 0
//	pceVectorSetTrap( 22 , TxLCDAsyncDone );
//
//	bp[0x281] &= ~0x01;		// DMA 荞݃NA (HSDMA Ch0̂)
//	bp[0x271] |= 0x01;		// DMA 荞݃Cl[u (HSDMA Ch0̂)
#endif
	TxLCDAsync( p, len, s1 );
}



static LCDWK *GetLCD( void )
{
	LCDWK *wp = &lcdwk; //(LCDWK *)0x800;
	//volatile unsigned char *bp = iop_c; 2003.02.16 N.SAWA 폜܂

	wp->buffp = wp->txbuff + 6;
	wp->cnt = 0;
	//bp[0x2d9] |= 0x03; 2003.02.16 N.SAWA 폜܂
	return wp;
}

static void ReleaseLCD( LCDWK *wp )
{
	{
		int len = (int)wp->cnt;
		if ( len ) {
			TxLCD( wp->buffp, len, 0 );
		}
	}
	{
		volatile unsigned char *bp = iop_c;
		volatile unsigned short *sp = (volatile unsigned short *)bp;
		while ( sp[0x822c/2] & 1 ) pdwait(5);
		while ( bp[0x1f7] & 0x20 ) pdwait(5);
		//bp[0x2d9] |= 0x03; 2003.02.16 N.SAWA 폜܂
	}
}

static void PutLCD1( LCDWK *wp, unsigned char a )
{
	asm volatile ( "mirror %0,%0" : "=r"(a) : "0"(a) ); // 2003.02.14 N.SAWA
	wp->buffp[wp->cnt++] = a;
}

static void PutLCDn( LCDWK *wp, const unsigned char *p, int len )
{
	unsigned char *q = &wp->buffp[wp->cnt];
	wp->cnt += len;
	do {
		unsigned char a = *p++;
		asm volatile ( "mirror %0,%0" : "=r"(a) : "0"(a) ); // 2003.02.14 N.SAWA
		*q++ = a;
	} while ( --len );
}

static void TxLCDImage( LCDWK *wp, int n, int m, unsigned len )
{
	unsigned char wk[3];

	wk[0] = 0xb0+n;			// Set Page Address
	wk[1] = 0x10+(m>>4);	// Set Column Address MSB
	wk[2] = 0x00+(m&15);	// Set Column Address LSB

	wp->cnt = -3;
	PutLCDn( wp, wk, 3 );

	TxLCD( wp->buffp-3, 3, 0 );

	TxLCD( wp->buffp, len*2, 1 );
}

#if 1
static void TxLCDImage2( LCDWK *wp, int n, int m, unsigned len, const unsigned char *gbuff )
{
	unsigned char wk[3];

	wk[0] = 0xb0+n;			// Set Page Address
	wk[1] = 0x10+(m>>4);	// Set Column Address MSB
	wk[2] = 0x00+(m&15);	// Set Column Address LSB

	wp->cnt = -3;
	PutLCDn( wp, wk, 3 );

	TxLCD( wp->buffp-3, 3, 0 );

	TxLCD( gbuff, len*2, 1 );
}
#else
//static unsigned char *MkDirect( void )
//{
//	unsigned char wk[3];
//	LCDWK *wp = &lcdwk; //(LCDWK *)0x800;
//	int n = ((9-dma_n)&15);
//	int m = 0;
//
//	wp->buffp = wp->txbuff + 6;
//	wp->cnt = 0;
//
//	wk[0] = 0xb0+n;			// Set Page Address
//	wk[1] = 0x10+(m>>4);	// Set Column Address MSB
//	wk[2] = 0x00+(m&15);	// Set Column Address LSB
//
//	PutLCDn( wp, wk, 3 );
//
//	return wp->buffp;
//}
//
//static void DirectDone2( void );
//
//static void DirectDone1( void )
//{
//	INT_BEGIN;
//	{
//		volatile unsigned char *bp = iop_c;
//
//		bp[0x281] &= ~0x01;		// DMA 荞݃NA (HSDMA Ch0̂)
//
//		pceVectorSetTrap( 22 , DirectDone2 );
//		TxLCDAsync( dma_p, 88*2, 1 );
//		dma_p += 88*2;
//		dma_n++;
//	}
//	INT_END;
//}
//
//static void DirectDone2( void )
//{
//	INT_BEGIN;
//	{
//		volatile unsigned char *bp = iop_c;
//
//		bp[0x281] &= ~0x01;		// DMA 荞݃NA (HSDMA Ch0̂)
//
//		if ( dma_n < 16 ) {
//			pceVectorSetTrap( 22 , DirectDone1 );
//			TxLCDAsync( MkDirect(), 3, 0 );
//		}
//		else {
//			bp[0x271] &= ~0x01;		// DMA 荞݋֎~ (HSDMA Ch0̂)
//		}
//	}
//	INT_END;
//}
#endif


void disp( void )
{
	int i;
	LCDWK *wp = GetLCD();

	for ( i = 0; i < 16; i++ ) {
#if 0
//		int j;
//		unsigned char *vp = wp->buffp;
//		for ( j = 0; j < 128; j++ ) {
//			if ( j < 96 ) {
//				*vp++ = ( 0-((i>>3)&1) );
//				*vp++ = ( 0-((i>>2)&1) );
//			}
//			else if ( j < 112 ) {
//				*vp++ = ( 0-((i>>2)&1) );
//				*vp++ = ( 0-((i>>1)&1) );
//			}
//			else if ( (i&7) > 3 ) {
//				*vp++ = 0xff;
//				*vp++ = 0xff;
//			}
//			else {
//				*vp++ = 0;
//				*vp++ = 0;
//			}
//		}
#else
		if ( !i ) memset( wp->buffp, 0, 128*2 );
#endif
		TxLCDImage( wp, ((9-i)&15), 0, 128 );	// Page Address, len
	}

	ReleaseLCD( wp );
}

void setup_disp2ns( void );
void setup_disp2ts( void );
void disp2ns( unsigned char *vp, unsigned char *gp, unsigned char *gpe ,int width);
void disp2ts( unsigned char *vp, unsigned char *gp, unsigned char *gpe ,int width);

void disp2n( int xs, int xe, int ys, int ye )
{
	int i, c = (( ye - ys ) << 3);
	unsigned char *gp = lcdbuff+(ys<<10);
	unsigned char *gpe = lcdbuff+(ye<<10);
	char powstr[4];                           //change 10/29
	LCDWK *wp = GetLCD();

	MakeBattStat(powstr);                     //change 10/29
	setup_disp2ns();

	for ( i = xs; i < xe; i++ ) {
		pdwait(24);
		disp2ns( wp->buffp, gp, gpe ,128);
		if ( powerdisp && (i>=(xe-4)) ) DispBattStatns(i-xe+4,wp->buffp,powstr); //change 10/29
		gp += 8;
		TxLCDImage( wp, ((9-i)&15), pagedir&2 ? 40 : 0, c );	// Page Address, len
	}

	ReleaseLCD( wp );
}

void disp2t( int xs, int xe, int ys, int ye )
{
	int i, c = (( xe - xs ) << 3);
	unsigned char *gp = lcdbuff+(xs<<3);
	char powstr[4];                           //change 10/29
	LCDWK *wp = GetLCD();

	MakeBattStat(powstr);                     //change 10/29
	xe<<=3;

	setup_disp2ts();

	for ( i = ys; i < ye; i++ ) {
		disp2ts( wp->buffp, gp, gp+xe ,128);
		if ( powerdisp && (i<(ys+4)) ) DispBattStatns(ys+3-i,wp->buffp,powstr); //change 10/29
		gp += (128*8);
		TxLCDImage( wp, ((i-6)&15), 0, c );	// Page Address, len
	}

	ReleaseLCD( wp );
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceLCDTransDirect
//! 
//! tʂɃobt@̓e𒼐ړ]܂B
//! 
//! void pceLCDTransDirect(
//! 		const unsigned char *lcd_direct	// ]̃obt@AhX
//! 		);
//! 
//! ߂lFȂ
//! 
//! obt@̓eLCDRg[̃obt@Ɠ`łB
//! 128x88/4=2816 oCg
//! 
//! ܂gƁAʏ̉zʂł̕`荂ɂłꍇ
//! 邩m܂񂪁AL̃fbg[łgB
//! iʏ̃Avł̎gp͂E߂܂Bj
//!
//!E\Ed\Agݍ݂̕`T[rX͎g܂B
//!ELCDW[̎dlύXɂȂꍇɁA]ނ悤
//!  ʂȂ\܂B
//!
void pceLCDTransDirect( const unsigned char *lcd_direct )
{
#if 0
//	dma_p = lcd_direct;
//	dma_n = 0;
//	pceVectorSetTrap( 22 , DirectDone1 );
//	TxLCDAsync( MkDirect(), 3, 0 );
#else
	int i;
	LCDWK *wp = GetLCD();

	for ( i = 0; i < 16; i++ ) {
		TxLCDImage2( wp, ((9-i)&15), 0, 88, lcd_direct );	// Page Address, len
		lcd_direct+=88*2;
	}

	ReleaseLCD( wp );
#endif
}



#ifdef NEWLCD
#define ICOM0 0
#else
//#define ICOM0 64
#endif

static const unsigned char lcd_init_data0[] = {
	//0xe2,			// Reset  2003.02.15 N.SAWA 폜܂
	0x48,	128,	// Set Partial Display Duty Select
	0xa0+0,			// ADC Select ( 0:SEG0->127  1:127->0 )
	0xc0+8,			// SHL Select ( 0:COM0->127  8:127->0 )
	0x44, ICOM0,	// Set Initial COM0 Registor
	0xab,			// Oscillator ON Start
	0x64+2,			// Select DC-DC Step-up ( 2: x5 )
	0x20+BL2,		// Select Regulator Resister
	0x50+6,			// Select LCD Bias ( 7: 1/12 )
	0x4c,  0x1f,    //
};

static const unsigned char lcd_init_data1[] = {
	//0xe2,			// Reset  2003.02.15 N.SAWA 폜܂
	0x48,	88,		// Set Partial Display Duty Select
	0xa0+0,			// ADC Select ( 0:SEG0->127  1:127->0 )
	0xc0+8,			// SHL Select ( 0:COM0->127  8:127->0 )
	0x44, ICOM0,	// Set Initial COM0 Registor
	0xab,			// Oscillator ON Start
	0x64+2,			// Select DC-DC Step-up ( 2: x5 )
	0x20+BL3,		// Select Regulator Resister
	0x50+5,			// Select LCD Bias ( 7: 1/12 )
};

static const unsigned char lcd_init_data2[] = {
	//0xe2,			// Reset  2003.02.15 N.SAWA 폜܂
	0x48,	128,	// Set Partial Display Duty Select
	0xa0+1,			// ADC Select ( 0:SEG0->127  1:127->0 )
	0xc0+0,			// SHL Select ( 0:COM0->127  8:127->0 )
	0x44, ICOM0,	// Set Initial COM0 Registor
	0xab,			// Oscillator ON Start
	0x64+2,			// Select DC-DC Step-up ( 2: x5 )
	0x20+BL2,		// Select Regulator Resister
	0x50+6,			// Select LCD Bias ( 7: 1/12 )
	0x4c,  0x1f,    //
};

static const unsigned char lcd_init_data3[] = {
	//0xe2,			// Reset  2003.02.15 N.SAWA 폜܂
	0x48,	88,		// Set Partial Display Duty Select
	0xa0+1,			// ADC Select ( 0:SEG0->127  1:127->0 )
	0xc0+0,			// SHL Select ( 0:COM0->127  8:127->0 )
	0x44, ICOM0,	// Set Initial COM0 Registor
	0xab,			// Oscillator ON Start
	0x64+2,			// Select DC-DC Step-up ( 2: x5 )
	0x20+BL3,		// Select Regulator Resister
	0x50+5,			// Select LCD Bias ( 7: 1/12 )
};

static const unsigned char lcd_init_dataE[] = {
	0x28+7,			// Power Control ( 7:All ON )
// 2003.02.24 N.SAWA lcdwk.display_onɏ]ON/OFF𕜌悤ɕύX̂ŁA͍폜܂B
//	(0xae)+1,		// Display ON/OFF ( 1:ON 0:OFF ) 2003.02.15 N.SAWA v1.18ł͂̍sRgAEgĂ̂A܂B
//                  //                                                 Zbg@\tgZbgn[hZbgɕύXɂȂ߁A
//                  //                                                 \tgZbgȂȑODisplay ON/OFFԂێ܂A
//                  //                                                 n[hZbgł͕KOFFɂȂĂ܂łB
//                  //                                                 {ON/OFFԂۑĂăn[hZbgɕ̂̂łA
//                  //                                                 Ƃ肠Zbg͏ONAœɖ͂ȂƔf܂B
//					//                                                 Ƃł̍sAu0xae+1vƏƁugarbage at end of numbervG[ɂȂ悤łB
//					//                                                   u0xae + 1vƂu(0xae)+1vȂnjłB䂾clu123E+10v̏Ɍ̂Ǝv
	0x40,	80,		// Set Initial Display Line Registor
};

static const unsigned char *const lcd_init_data[] = {
	lcd_init_data0,
	lcd_init_data1,
	lcd_init_data2,
	lcd_init_data3,
};

static const unsigned char lcd_init_len[] = {
	sizeof(lcd_init_data0),
	sizeof(lcd_init_data1),
	sizeof(lcd_init_data2),
	sizeof(lcd_init_data3),
};

#define lcd(a) PutLCD1(wp,(a))

static void pal( LCDWK *wp, int n, unsigned short d )
{
	n<<=1;
	lcd( 0x88+n );
	lcd( d&255  );
	lcd( 0x89+n );
	lcd( d>>8   );
}

//
// LCD̊eWX^̐ݒ
//
void setup_lcd_params1( void )
{

	LCDWK *wp = GetLCD();

	//{{2003.02.14 N.SAWA
	volatile unsigned char *bp = iop_c;
	bp[0x2dd] &= ~0x08;	// P33 LCD Reset nm
	pdwait(1000);		// 1}CNbȏKvBÔ߂Ȃ蒷߂ɂĂ܂B炵ĂłB
	bp[0x2dd] |=  0x08;	// P33 LCD Reset 
	pdwait(1000);		// 1}CNbȏKvBÔ߂Ȃ蒷߂ɂĂ܂B炵ĂłB
	//}}2003.02.14 N.SAWA

	PutLCDn( wp, lcd_init_data[pagedir], lcd_init_len[pagedir] );

	lcd( 0x81 );	// Select Electric Volume Resister
	lcd( brightness );

	lcd( 0x94 );	// Set PWM & FRC mode
	pal( wp, 0, 0x000 ); // 邢
	pal( wp, 1, 0x008 ); // 
	pal( wp, 2, 0x088 ); // 
	pal( wp, 3, 0x888 ); // Â

	PutLCDn( wp, lcd_init_dataE, sizeof(lcd_init_dataE) );

	if(wp->display_on) PutLCD1(wp, 0xae + 1); // 2003.02.24 N.SAWA n[hZbg͉ʕ\OFFɂȂĂ̂ŁAZbgOON畜܂B

	ReleaseLCD( wp );

	disp();
}



//!///// Piece Kernel Service API Reference
//! 
//!  pceLCDDispStart
//! 
//! tʂ̕\Jn܂B
//! 
//! void pceLCDDispStart( void )
//! 
//! ߂lFȂ
//!
void pceLCDDispStart( void )
{
	LCDWK *wp = GetLCD();
	lcd( 0xae + 1 );	// Display ON/OFF ( 1:ON 0:OFF )
	wp->display_on = 1;	// 2003.02.24 N.SAWA Zbgɕ邽߁Aʕ\ԂۑĂ
	ReleaseLCD( wp );
}

//!///// Piece Kernel Service API Reference
//! 
//!  pceLCDDispStop
//! 
//! tʂ̕\~܂B
//! 
//! void pceLCDDispStop( void )
//! 
//! 
//! ߂lFȂ
//!
void pceLCDDispStop( void )
{
	LCDWK *wp = GetLCD();
	lcd( 0xae + 0 );	// Display ON/OFF ( 1:ON 0:OFF )
	wp->display_on = 0;	// 2003.02.24 N.SAWA Zbgɕ邽߁Aʕ\ԂۑĂ
	ReleaseLCD( wp );
}

//!///// Piece Kernel Service API Reference
//! 
//!  pceLCDTrans
//! 
//! tʂɃobt@̓e]܂B
//! 
//! void pceLCDTrans( void );
//! 
//! ߂lFȂ
//!
//! ⏈ɎԂ܂B
//!
//!
void pceLCDTrans( void )
{
	pceLCDTransRange(0,0,127,87);
}


// p
void pceLCDTransRange( int xs, int ys, int xe, int ye )
{
	xs>>=3;
	ys>>=3;
	xe+=8;
	ye+=8;
	xe>>=3;
	ye>>=3;
	//if ( powerdisp && !xs ) DispBattStat(); //change 10/29
	if ( pagedir & 1 ) disp2t(xs,xe,ys,ye); else disp2n(xs,xe,ys,ye);
}


//!///// Piece Kernel Service API Reference
//! 
//!  pceLCDSetBuffer
//! 
//! tʕ\̂߂̉zʂ̃obt@EAhXݒ肵܂B
//! 
//! unsigned char *pceLCDSetBuffer(
//! 		unsigned char *pbuff	// obt@EAhX
//! 		);
//! 
//! ߂lFȑÕobt@EAhX
//! 
//! pbuff  INVALIDPTR w肷ƐVl͐ݒ肳܂B
//! ܂茻݂̐ݒlύXɎ擾邱Ƃo܂B
//! 
//! obt@̍\1hbg1oCg
//! i2rbĝݎgp=4FA6rbg0Ŗ߂Ăj
//! 128hbg~c88hbg = 11246oCg
//!@
//! pbuff+---------... ...------------+
//!        |                            |
//!        |                            |  
//!        .                            .
//!        .                            .  Y 88 hbg
//!        .                            .
//!        |                            |  
//!        |                            |
//!        +---------... ...------------+
//!                X 128 hbg
//!@
//! ̃obt@ύXł́A\eɂ͔f܂B
//! pceLCDTrans() ĂяoĎʂɔfKv܂B
//! 
//! ӁI
//! pbuff ̃AhX 4 ̔{ɃACgĂKv
//! ܂BʏCR[fBOȂSzv܂B
//! 
unsigned char *pceLCDSetBuffer( unsigned char *pbuff )
{
	unsigned char *old = lcdbuff;
	if ( pbuff != INVALIDPTR ) lcdbuff = pbuff;
	return old;
}

//!///// Piece Kernel Service API Reference
//! *v1.11+
//! 
//!  pceLCDSetOrientation
//! 
//! tʂ̕\ݒ肵܂B
//!
//! int pceLCDSetOrientation(
//!			int dir			// \  0 ` 3 (4)
//!			);
//!			
//!
//! ߂lFȑO̕\
//! 
//! dir  INVALIDVAL w肷ƐVl͐ݒ肳܂B
//! ܂茻݂̐ݒlύXɎ擾邱Ƃo܂B
//! 
//! zAPI͉tpl̕ύXɂdlς\łB
//!     ܂AiłŗL𑶑邩͖łB
//! 
//! v1.11ȍ~ł́AAPIł pceLCDTrans() Ȃ悤
//! ύXɂȂ܂B
//! 
int pceLCDSetOrientation( int dir )
{
	int old = pagedir;
	if ( dir != INVALIDVAL ) {
		if ( dir >= 4 ) dir = 0;
		pagedir = dir;
		setup_lcd_params1();
		//pceLCDTrans(); v1.11 ō폜
	}
	return old;
}

//!///// Piece Kernel Service API Reference
//! 
//!  pceLCDSetBright
//! 
//! tʂ̖邳iZjݒ肵܂B
//!
//! int pceLCDSetBright(
//!			int bright		// 邳
//!			);
//!
//! 
//! ߂lFȑO̖邳
//! 
//! 邢() 0 ` 63 Â(Z)
//! 
//! bright  INVALIDVAL w肷ƐVl͐ݒ肳܂B
//! ܂茻݂̐ݒlύXɎ擾邱Ƃo܂B
//! 
//! ӁI
//! ̃p[^̓[UVXej[ŒEݒ肷
//! p[^Ȃ̂ŁAʏ̃AvP[Vgp̂
//! D܂܂B
//! 
int pceLCDSetBright( int bright )
{
	int old = brightness;
	if ( bright != INVALIDVAL ) {
		if ( bright < 0 ) bright = 0;
		if ( bright >= 64 ) bright = 63;
		brightness = bright;
		{
			LCDWK *wp = GetLCD();
			lcd( 0x81 );	// Select Electric Volume Resister
			lcd( brightness );
			ReleaseLCD( wp );
		}
	}
	return old;
}



void InitSPI( void )
{
	volatile unsigned char *bp = iop_c;

	bp[0x2da] |= 0x03;	//
	bp[0x2d9] &= ~0x01;	// 2003.02.16 N.SAWA P20(CSB)͏グςȂBP21(RS)̂ݐݒAł͏svB

	bp[0x2dd] |= 0x08;	// P33 LCD Reset 

	bp[0x140] = 0x02;	// 8rbg^C} ch5 
	bp[0x145] = 0x80;	// 8rbg^C} ch5 vXP[I
	bp[0x179] = 2-1;	// 8rbg^C} ch5 [hlݒ
	bp[0x178] = 0x07;	// 8rbg^C} ch5 
	// VÃNbN͂ɂ1/2ɂȂ܂B

	bp[0x1f9] = 0x00;	// VA ch3 C^[tF[X[h
	bp[0x1f8] = 0x00;	// VA ch3 
	bp[0x2d7] = 0x0e;	// P32,15,16 VAp

	bp[0x1f8] = 0x80;	// VA ch3 

	while ( !(bp[0x1f7] & 2) ) pdwait(10);
	bp[0x1f5] = 0xe3;	// NOP

	// for HSDMA
	bp[0x298] &= 0xf0;
	bp[0x298] |= 0x09;	// HSDMA Ch0 gKݒ (16bit^C}ch4 cmp.A)
	bp[0x2cb] =  0x08;	// 16bit^C}ch4 cmp.A -> SIO Ch3 TXD Emp.
	bp[0x263] &= 0xf0;
	bp[0x263] |= 0x06;	// HSDMA Ch0/1 荞݃vCIeB(Ch0=6)
}



void InitLCD( void )
{
	InitSPI();

#ifdef REVUD
//	pagedir = 2;
#else
	pagedir = 0;
#endif
	brightness = BL1;

	setup_lcd_params1();

	pceVectorSetKs(KSNO_LCDDispStart, pceLCDDispStart);
	pceVectorSetKs(KSNO_LCDDispStop, pceLCDDispStop);
	pceVectorSetKs(KSNO_LCDTrans, pceLCDTrans);
	pceVectorSetKs(KSNO_LCDTransDirect, pceLCDTransDirect);
	pceVectorSetKs(KSNO_LCDTransRange, pceLCDTransRange);
	pceVectorSetKs(KSNO_LCDSetBuffer, pceLCDSetBuffer);
	pceVectorSetKs(KSNO_LCDSetOrientation, pceLCDSetOrientation);
	pceVectorSetKs(KSNO_LCDSetBright, pceLCDSetBright);

	// d҂
	{
		volatile unsigned char *bp = iop_c;
		while ( bp[0x153] & 0x08 ) pdwait(10);
		while ( !(bp[0x153] & 0x08) ) pdwait(10);
	}

	// P񏉊 (d̈萫)
	setup_lcd_params1();
}

//
// X^oC[h̏ȓd͉̂
//

static const unsigned char lcd_set_dataPS1[] = {
	0xa8+1,			// Set Power Save Mode ( 1:Sleep )
};

static const unsigned char lcd_set_dataPS0[] = {
	0xe1,			// Release Power Save Mode
};

void SleepLCD( void )
{
	LCDWK *wp = GetLCD();
	PutLCDn( wp, lcd_set_dataPS1, sizeof(lcd_set_dataPS1) );
	ReleaseLCD( wp );
}


void RestartLCD( void )
{
	LCDWK *wp = GetLCD();
	PutLCDn( wp, lcd_set_dataPS0, sizeof(lcd_set_dataPS0) );
	ReleaseLCD( wp );
}

