
/////////////////////////////////////////////////////////////////////////////
//
//             /
//      -  P  /  E  C  E  -
//           /                 mobile equipment
//
//              System Programs
//
//
// PIECE KERNEL : Ver 1.00
//
// Copyright (C)2001-2002 AUQAPLUS Co., Ltd. / OeRSTED, Inc. all rights reserved.
//
// Coded by MIO.H (OeRSTED)
//
// Comments:
//
//  WAVEo̓hCo[łB
//
//  v1.00 2001.11.09 MIO.H
//  v1.01 2001.11.27 Katsumasa Tsuneyosi ADPCMǉ
//  v1.08 2001.11.29 MIO.H	Jn/ĨmCY𖳂
//  v1.09 2001.11.30 MIO.H	ĐIINFO\̍폜s̃oOC
//  v1.16 2002.01.05 MIO.H	ς݂̃obt@ɏރoOC
//  v1.18 2002.01.16 MIO.H	snd_flg ݒ
//  v1.19 2003.02.16 N.SAWA	Ђ悱΍
//  v1.19 2003.04.03 N.SAWA	pceWaveDataOut̐C
//



#include <stdio.h>
#include <string.h>
#include <piece.h>
#include "pcekn.h"


//#define PWMC (544)		// 44.1kHz
#define PWMC (750)		// 32kHz
#define PWMC2 (PWMC-1)

#define MAXCH 4			// ő`l

#define WBLK 64			// 1ubN̏

#define TMCNT  (344*3)	// 3b

typedef unsigned char WAVE8;
typedef signed short WAVE16;
typedef signed long WAVE32;

extern WAVE16 sintbl[];
extern signed short dbtbl[];

typedef struct tagWAVEPLAY {
	PCEWAVEINFO *pwi;
	PCEWAVEINFO *pwi00;
	PCEWAVEINFO *pwiee;
	signed short cvol;		// ŐṼ{[l
	signed char att;
	signed char resv;
} WAVEPLAY;

static WAVEPLAY waveplay[MAXCH];

static WAVE32 xwave_buff[WBLK];		// pobt@
unsigned short sound_buff[256];		// ŏIo͗pobt@

static unsigned char mywaveinfo[4*28];	// Ɨp WAVEINFO+ ~ 4ch

static SYNCVAR snd_proccnt;

static unsigned short wave_stat;
static unsigned short prevd;

volatile unsigned char sound_ptr;
static unsigned char ma_att;
static unsigned char snd_powersave;


static void init_sound_buff( void )
{
	int i;

	for ( i = 0; i < 256; i++ ) sound_buff[i] = PWMC2;

	sound_ptr = 0;

	prevd = PWMC2;
}




static void stop_pcm( void )
{
	volatile unsigned char *bp = iop_c;
	volatile unsigned short *sp = iop_s;

	if ( snd_powersave ) {
		bp[0x2dd] |= 0x02;		// P31 = HIGH
	}

	sp[0x823e/2] = 0;		// HSDMA Ch1 gK
	sp[0x823c/2] = 0;		// HSDMA Ch1 Cl[u
	bp[0x271] &= ~0x02;		// DMA 荞݋֎~ (HSDMA Ch1̂)
//	bp[0x273] &= ~0x04;		// 16bit^C}2 荞 OFF

	use_dma &= ~1;
}


void sound_isr3( void );

static void start_pcm( void )
{
	volatile unsigned char *bp = iop_c;
	volatile unsigned short *sp = iop_s;
	volatile unsigned long *wp = iop_w;

	bp[0x2dd] &= ~0x02;		// P31 = LOW

	init_sound_buff();
#if 0
	sp[0x148/2] = 0;		// 16bit^C}1,2 NbN OFF

	// Lch PWM g 16bit^C}1

	sp[0x8188/2] = PWMC;	// 16bit^C}1 RyAf[^A
	sp[0x818a/2] = PWMC-1;	// 16bit^C}1 RyAf[^B
	bp[0x818e] = 0x77;		// 16bit^C}1 

	bp[0x2d8] |= 0x08;		// P23  TM1 

	bp[0x148] = 0x08;		// 16bit^C}1 NbN IN 1/1
#endif
	// HSDMA Ch1-TM1

	wp[0x8230/4] = 128|0x80000000;				// HSDMA Ch1 ]JEg
	wp[0x8234/4] = (int)sound_buff|0xf0000000;	// HSDMA Ch1 ]AhX
	wp[0x8238/4] = 0x48188;						// HSDMA Ch1 ]AhX

	sp[0x823e/2] = 1;						// HSDMA Ch1 gK
	sp[0x823c/2] = 1;						// HSDMA Ch1 Cl[u

	bp[0x271] |= 0x02;		// DMA 荞݃Cl[u (HSDMA Ch1̂)

	use_dma |= 1;
}

short dct[]={
  233,549,453,375,310,233,233,233,
  233,233,233,233,310,375,453,549,
};
#if 0
WAVE16 *make_xwave16( WAVE32 *dp, WAVE16 *sp, int len, int vol )
{
		do {
			*dp++ += *sp++ * vol;
		} while ( --len );
		return sp;
}

WAVE8 *make_xwave8( WAVE32 *dp, WAVE8 *sp, int len, int vol )
{
		vol <<= 8;
		do {
			*dp++ += (*sp++ - 128) * vol;
		} while ( --len );
		return sp;
}

int make_buff44( unsigned short *dp, WAVE32 *sp, int len, int prevd )
{
	do {
		unsigned short a = PWMC2 + (( *sp++ ) >> 16);
		*dp++ = ((a+prevd)>>1);
		*dp++ = a;
		prevd = a;
	} while ( --len );
	return prevd;
}

/*
   resv0:delta
   resv1:pcm
   resv2:ct

   adct :JE^
   adsi :ώZWX^
*/

unsigned char *make_xwavead0( WAVE32 *dp, PCEWAVEINFO *pwi, int len, int vol )
{
  unsigned char *sp=(unsigned char*)pwi->pData;
  int delta=pwi->resv0,pcm=pwi->resv1,ct=pwi->resv2;
  do{
    if(ct==0){
      int ad;
      ct=*sp++;
      ad=ct>>4;
      ct|=16;
      pcm+=delta*(ad-8);
      delta=(delta*dct[ad])>>8;
      *dp++ += pcm*vol;
    }else{
      ct&=0xf;
      pcm+=delta*(ct-8);
      delta=(delta*dct[ct])>>8;
      *dp++ += pcm*vol;
      ct=0;
    }
  }while( --len );
  pwi->resv0=delta;
  pwi->resv1=pcm;
  pwi->resv2=ct;
  return sp;
}

unsigned char *make_xwavead1( WAVE32 *dp, PCEWAVEINFO *pwi, int len, int vol )
{
  unsigned char *sp=(unsigned char*)pwi->pData;
  int delta=pwi->resv0,pcm=pwi->resv1,ct=pwi->resv2;
  int pre=pcm*vol;
  unsigned int cadd=(pwi->adct)>>2,creg=(pwi->adsi)>>2;
  do{
    creg+=cadd;
    if(creg&0x40000000){
      creg&=0x3fffffff;
      if(ct==0){
	int ad;
	ct=*sp++;
	ad=ct>>4;
	ct|=16;
	pcm+=delta*(ad-8);
	delta=(delta*dct[ad])>>8;
	pre = pcm*vol;
      }else{
	ct&=0xf;
	pcm+=delta*(ct-8);
	delta=(delta*dct[ct])>>8;
	pre = pcm*vol;
	ct=0;
      }
    }
    *dp++ += pre;
  }while( --len );
  pwi->resv0=delta;
  pwi->resv1=pcm;
  pwi->resv2=ct;
  pwi->adsi=creg<<2;
  return sp;
}


#else
extern WAVE16 *make_xwave16_fast( WAVE32 *dp, WAVE16 *sp, int len, int vol );
extern WAVE8 *make_xwave8_fast( WAVE32 *dp, WAVE8 *sp, int len, int vol );
extern int make_buff44_fast( unsigned short *dp, WAVE32 *sp, int len, int prevd );
extern unsigned char *make_xwavead0_fast( WAVE32 *dp, PCEWAVEINFO *pwi, int len, int vol );
extern unsigned char *make_xwavead1_fast( WAVE32 *dp, PCEWAVEINFO *pwi, int len, int vol );
#define make_xwave16 make_xwave16_fast
#define make_xwave8 make_xwave8_fast
#define make_xwavead0 make_xwavead0_fast
#define make_xwavead1 make_xwavead1_fast
#define make_buff44 make_buff44_fast
#endif




#if 0
	if(((pwave->type & PW_TYPE_ADP_NOTINI)==0)&&
	   (((pwave->type&0xf)==PW_TYPE_ADPCM)||
	    ((pwave->type&0xf)==PW_TYPE_ADPCM_V))){
	  pwave->resv0=16;
	  pwave->resv1=0;
	  pwave->resv2=0;
	  pwave->adsi=0xffffffff;
	}
#endif


static void setpwi( WAVEPLAY *wp, PCEWAVEINFO *wip, PCEWAVEINFO *newp )
{
	if ( newp ) {
		//newp->stat = PW_STAT_START; vȂ
		wp->pwi = wip;
		wp->pwi00 = newp;
		*wip = *newp;
		if ( wip->type & PW_TYPE_ADP_INI ) {
			unsigned short *sp = (unsigned short *)((unsigned char *)wip + 20);
			sp[0] = 16;
			sp[1] = 0;
			sp[2] = 0;
			sp[3] = 0;
		}
		if ( !(wip->type & PW_TYPE_VR) ) {
			wip->resv = 16000;
		}
	}
	else {
		wp->pwi = newp;
	}
}






void make_xwave( void )
{
	if ( !wave_stat ) return;

	wave_stat--;

	if ( wave_stat > TMCNT-3 ) {
		WAVEPLAY *wp = waveplay;
		int i;

		memset( xwave_buff, 0, sizeof(xwave_buff) );

		for ( i = 0; i < MAXCH; wp++,i++ ) {
			PCEWAVEINFO *pwi = wp->pwi;
			if ( pwi ) {
				WAVE32 *p = xwave_buff;
				int d = WBLK;
				while ( d ) {
					int c = pwi->len;
					if ( c > d ) c = d;
					if ( c ) {
						pwi->len -= c;
						switch(pwi->type & 3){
						case 0:		// 8bit
							pwi->pData = make_xwave8( p, (WAVE8 *)pwi->pData, c, wp->cvol );
							break;
						case 1:		// 16bit
							pwi->pData = make_xwave16( p, (WAVE16 *)pwi->pData, c, wp->cvol );
							break;
						case 2:     // adpcm
							pwi->pData = make_xwavead1( p, pwi, c, wp->cvol );
							break;
						}
						d -= c;
						p += c;
					}
					if ( !pwi->len ) {
						wp->pwiee = wp->pwi00;
						//wp->pwiee->stat = PW_STAT_END; vȂ
						setpwi( wp, wp->pwi, pwi = pwi->next );
						if ( !pwi ) break;
					}
				}
				wave_stat = TMCNT;
			}
		}

#if 0
		{
			unsigned short *q = sound_buff + ((sound_ptr & 0x80)^ 0x80);
			WAVE32 *p = xwave_buff;
			unsigned short b = prevd;
			for ( i = 0; i < WBLK; i++ ) {
				unsigned short a = PWMC2 + (( *p++ ) >> 16);
				*q++ = ((a+b)>>1);
				*q++ = a;
				b = a;
			}
			prevd = b;
		}
#else
		prevd = make_buff44(
			sound_buff + ((sound_ptr & 0x80)^ 0x80),
			xwave_buff,
			WBLK,
			prevd );
#endif

		wp = waveplay;
		for ( i = 0; i < MAXCH; wp++,i++ ) {
			PCEWAVEINFO *pwi = wp->pwiee;
			if ( pwi ) {
				wp->pwiee = NULL;
				if ( pwi->pfEndProc ) pwi->pfEndProc( pwi );
			}
		}

//		*(unsigned char *)0x402dd &= ~0x02;		// P31 = LOW
	}
	else if ( wave_stat == TMCNT-3 ) {
		init_sound_buff();
	}
	else if ( !wave_stat ) {
		ENTER_CS;
		stop_pcm();
		LEAVE_CS;
	}
}



void sound_isr3( void )
{
	INT_BEGIN2;
	{
		volatile unsigned char *bp = iop_c;
		volatile unsigned short *sp = iop_s;
		volatile unsigned long *wp = iop_w;
		int a = sound_ptr ^ 0x80;

		bp[0x281] &= ~0x02;	//

		wp[0x8234/4] = (int)(sound_buff+a)|0xf0000000;	// HSDMA Ch1 ]AhX
		wp[0x8230/4] = 128|0x80000000;					// HSDMA Ch1 ]JEg

		sp[0x823c/2] = 1;							// HSDMA Ch1 Cl[u

		sound_ptr = a;

	}
	{
		if ( ++snd_proccnt == 1 ) {
			snd_flg = 1;
			SET_SIL5;
			do {
				make_xwave();
			} while ( pceSyncSafetyAddition( &snd_proccnt, -1 ) );
			snd_flg = 0;
		}
	}
	INT_END2;
}


signed short volcalc( int att )
{
	if ( att <= 63 ) return ( dbtbl[att] * PWMC * 2 ) >> 14;
	return 0;
}



///////////////////////////////////////////////////////////////////////////////
//
//
//  API
//

//!///// Piece Kernel Service API Reference
//! 
//!  pceWaveCheckBuffs
//! 
//! ҋ@܂߂WAVEo̓f[^Eobt@̌擾܂
//! 
//! int pceWaveCheckBuffs(
//! 		int ch			// o ch ( 0 ` 3 )
//! 		);
//! 
//! ߂lFobt@
//! 
//! pceWaveDataOut() ŏo͂Ă܂o͂IĂȂobt@
//! 𓾂܂B
//!

static int _pceWaveDataCheckBuffs( int ch )
{
	WAVEPLAY *wp = waveplay + ch;
	PCEWAVEINFO *pwi;
	int n = 0;

	ENTER_CS;

	pwi = wp->pwi;
	while ( pwi ) {
		pwi = pwi->next;
		n++;
	}

	LEAVE_CS;

	return n;
}



//!///// Piece Kernel Service API Reference
//! *v1.07+
//! 
//!  pceWaveDataOut
//! 
//! WAVEf[^o͂܂
//! 
//! int pceWaveDataOut(
//! 		int ch,				// o ch ( 0 ` 3 )
//! 		PCEWAVEINFO *pwave	// WAVE\̂ւ̃|C^
//! 		);
//! 
//! ߂lF0(ɐ)
//! 
//! pwave ̏ɏ]WAVEf[^o͂܂B
//! *pwave ̓e̓VXep郏[NƂȂ܂̂
//! o͂IĊJ܂ŃAvP[VύXĂ
//! ܂B
//! RłAWAVEf[^ĐI܂ł͕KvłB
//! 
//! TvOgADPCM ώg 16kHz ݂̂łB
//! 
//!@
//!  PCEWAVEINFO\̂̓e
//! typedef struct tagPCEWAVEINFO {
//!    volatile unsigned char stat;                 // 0  Xe[^X
//!    unsigned char type;                          // 1  f[^`
//!    unsigned short resv;                         // 2  \
//!    void *pData;                                 // 4  f[^ւ̃|C^
//!    unsigned long len;                           // 8  f[^̒(Tv)
//!    struct tagPCEWAVEINFO *next;                 // 12 ւ̃|C^
//!    void (*pfEndProc)( struct tagPCEWAVEINFO *); // 16 IR[obN
//! } PCEWAVEINFO;
//!
//! volatile unsigned char stat : Xe[^X
//!
//!   gpȂȂ܂B(v1.16ȍ~)
//!
//! unsigned char type : f[^`
//!
//!   PW_TYPE_8BITPCM    0       8bit jA PCM ( l 0x80 )
//!   PW_TYPE_16BITPCM   1       16bit jA PCM ( l 0 )
//!   PW_TYPE_ADPCM      0x22    4bit ADPCM ( P/ECEp )
//!   PW_TYPE_ADPCM_V    0x62    4bit ADPCM ώg( P/ECEp )
//!   PW_TYPE_CONT       0x10    Ao̓[h
//!@
//!   PW_TYPE_CONT OR(|)őgݍ킹Ďg܂B
//!   PW_TYPE_CONTrbg0̏ꍇ́Aݏo͒̃obt@
//!   jAɐVf[^̍ĐJn܂B
//!   PW_TYPE_CONTrbg1̏ꍇ́Aݏo͒̃obt@̌
//!   ǉAҋ@ԂɂȂ܂B
//!
//!   v1.07ȍ~ ADPCM g܂B
//!   ADPCM̏ꍇ͈ȉ̃tOrbg̕(OR)łB
//!   ׂĎgp΁AADPCM ł PW_TYPE_CONT łꂢ
//!   Đł܂B
//!
//!@
//!   PW_TYPE_4BITADPCM    2      4bit ADPCM
//!   PW_TYPE_ADP_INI      0x20   ADPCM֌W̃p[^܂
//!   PW_TYPE_VR           0x40   ώgiADPCM̂݁j
//!
//!
//! unsigned short resv : \
//!@
//!     tH[}bgɂgp@قȂ܂B
//!
//!     ADPCMώgɂ́AĐgݒ肵܂B
//!     wl/16000 {̃sb`ōĐ܂B
//!     AA16000 zl͎w肵ȂłB
//!     Đ̕ۏ؂͂ł܂B
//!
//!     ȊȌꍇ́A0 ɂĂB
//!
//!@
//! void *pData : f[^ւ̃|C^
//!@
//!     g`f[^ւ̃|C^łB
//!     8bitunsigned charA16bitsigned shortւ̃|C^łB
//!     g`f[^͍ĐI܂ŁAAvP[Vł͔jȂ
//!     B
//!@
//! unsigned long len : f[^̒(Tv)
//!@
//!     f[^̒łBoCgłȂTvłB
//!     16bit̓oCg1/2ĂB
//!     8bit̓oCĝ܂܂łB
//!     ADPCM̓oCg2{ĂB
//!     ADPCMώg͈L΂Tv𑝂₷Kv܂B
//!@
//! struct tagPCEWAVEINFO *next : ւ̃|C^
//!@
//!     VXeŎgpÃobt@ւ̃|C^łB
//!     Ăяo NULL ɂĂB
//!@
//! void (*pfEndProc)( struct tagPCEWAVEINFO *) : IR[obN
//!@
//!     obt@̍ĐIiJjƂɌĂяo܂B
//!     ĂяoKvȂꍇ NULL w肵B
//!

static int _pceWaveDataOut( int ch, PCEWAVEINFO *pwave )
{
	WAVEPLAY *wp = waveplay + ch;
	PCEWAVEINFO *pwi;
	CRITICAL_SECTION cs; // ӁIENTER/LEAVE_CS̓}NɁu{vu}v܂ނ̂ŁÅ֐ł͎g܂I

	pceSyncEnterCriticalSection( &cs );

RETRY:
	pwi = wp->pwi;
	if ( pwi && (pwave->type & PW_TYPE_CONT) ) {
		// 2003.02.16 N.SAWA Ђ悱΍
		while ( pwi->next ) { // `FC̐擪͓[NwĂ̂Ő΂ɈvȂ͂BsvB
			pwi = pwi->next;
			// E`lɓobt@do^ꂽAɓo^ꂽobt@J܂ő҂܂B
			// @Aobt@do^ĂAЕ`FC擪i[NjɓĂ܂Ă΁A
			// @͓̂[NnextłA`FCɂ͂ȂȂ̂Łuo^vƂ܂B
			// E{͓`lłȂAS`l̃`FC𑖍ēdo^oׂȂ̂łA
			// @\Ƃ̃g[hItŁA͓`lւ̓do^𒲂ׂ邱Ƃɂ܂B
			// @肪o悤łAS`l̃`FC𑖍悤ɕύXĂB
			if ( pwi == pwave ) {
				pceSyncLeaveCriticalSection( &cs );
				pdwait( 1000 );
				pceSyncEnterCriticalSection( &cs );
				goto RETRY;
			}
		}
		pwi->next = pwave;
	}
	else {
		// obt@Ƀf[^Ȃꍇ͂ǂłłB
		setpwi( wp, (PCEWAVEINFO *)(mywaveinfo + ch*28), pwave );
		if ( !wave_stat ) start_pcm();
		wave_stat = TMCNT;
	}

	pceSyncLeaveCriticalSection( &cs );

	return 0;
}



//!///// Piece Kernel Service API Reference
//! 
//!  pceWaveAbort
//! 
//! WAVEo͂𒆎~܂B
//! 
//! int pceWaveAbort(
//! 		int ch			// o ch ( 0 ` 3 )
//! 		);
//! 
//! ߂lF0(ɐ)
//! 
//! w肳ꂽ ch  WAVE o͂Iɒ~܂B
//! Đҋ@̃obt@͔j܂B
//! 

static int _pceWaveAbort( int ch )
{
	WAVEPLAY *wp = waveplay + ch;

	ENTER_CS;

	wp->pwi = NULL;
	wp->pwiee = NULL;

	LEAVE_CS;
	
	return 0;
}



//!///// Piece Kernel Service API Reference
//! 
//!  pceWaveSetChAtt
//! 
//! ch ̌ʁiʁjw肵܂B
//! 
//! int pceWaveSetChAtt(
//! 		int ch,			// o ch ( 0 ` 3 )
//! 		int att			// (dB) 0 ` 127
//! 		);
//! 
//! ߂lFȑO̐ݒl
//! 
//! e ch ̌ʁiʁj 1dB PʂŎw肵܂B
//! 0 ōőA127 ōŏłAʂ傫(50dB`)Ȃ
//! ܂萸x͂܂B
//! 
//! att  INVALIDVAL w肷ƐVl͐ݒ肳܂B
//! ܂茻݂̐ݒlύXɎ擾邱Ƃo܂B
//! 
static int _pceWaveSetChAtt( int ch, int att )
{
	WAVEPLAY *wp = waveplay + ch;

	if ( att != INVALIDVAL ) {
		wp->att = att;
		wp->cvol = volcalc( ma_att + att );
	}

	return wp->att;
}



//!///// Piece Kernel Service API Reference
//! 
//!  pceWaveSetMasterAtt
//! 
//! Ŝ̌ʁiʁjw肵܂B
//! 
//! int pceWaveSetMasterAtt(
//! 		int att			// (dB) 0 ` 127
//! 		);
//! 
//! ߂lFȑO̐ݒl
//! 
//! S ch ̌ʁiʁj 1dB PʂŎw肵܂B
//! 0 ōőA127 ōŏłAʂ傫(50dB`)Ȃ
//! ܂萸x͂܂B
//! 
//! att  INVALIDVAL w肷ƐVl͐ݒ肳܂B
//! ܂茻݂̐ݒlύXɎ擾邱Ƃo܂B
//! 
//! //! ӁI
//! ̃p[^̓[UVXej[ŒEݒ肷
//! p[^Ȃ̂ŁAʏ̃AvP[Vgp̂
//! D܂܂B
//! 
static int _pceWaveSetMasterAtt( int att )
{

	if ( att != INVALIDVAL ) {
		WAVEPLAY *wp = waveplay;
		int i;

		ma_att = att;
		for ( i = 0; i < MAXCH; wp++,i++ ) {
			wp->cvol = volcalc( wp->att + att );
		}
	}

	return ma_att;
}



//!///// Piece Kernel Service API Reference
//! 
//!  pceWaveStop
//! 
//! ݑҋ@ׂ̂Ẵobt@JAɍĐ~܂B
//! 
//! void pceWaveStop(
//! 		int hard	// n[hEGA̍Đ@\̐tO
//! 		);
//! 
//! ߂lFȂ
//! 
//! tO
//!     =0 X^oĈ܂ܑҋ@Aȏ㖳̏ꍇn[hIɂ~܂B
//!     =1 n[hIɂ~܂B
//! 
//! 
static void _pceWaveStop( int hard )
{
	WAVEPLAY *wp = waveplay;
	int i;

	ENTER_CS;

	for ( i = 0; i < MAXCH; wp++,i++ ) {
		wp->pwi = NULL;
		wp->pwiee = NULL;
	}

	if ( hard ) {
		stop_pcm();
		wave_stat = 0;
	}

	LEAVE_CS;
}



int sndSetPowersave( int mode )
{
	if ( mode != INVALIDVAL ) {
		volatile unsigned char *bp = iop_c;
		ENTER_CS;
		snd_powersave = mode;
		if ( mode ) {
			if ( !wave_stat ) stop_pcm();
		}
		else {
			bp[0x2dd] &= ~0x02;		// P31 = LOW
		}
		LEAVE_CS;
	}
	return snd_powersave;
}




void InitSound( void )
{
	int i;
	{
		volatile unsigned char *bp = iop_c;
		volatile unsigned short *sp = iop_s;

		bp[0x298] &= 0x0f;
		bp[0x298] |= 0x60;		// HSDMA Ch1 gKݒ (16bit^C}ch1 cmp.B)
		bp[0x263] &= 0x0f;
		bp[0x263] |= 0x70;		// HSDMA Ch0/1 荞݃vCIeB(Ch1=7)

		// Lch PWM g 16bit^C}1

		sp[0x148/2] = 0;		// 16bit^C}1,2 NbN OFF

		sp[0x8188/2] = PWMC;	// 16bit^C}1 RyAf[^A
		sp[0x818a/2] = PWMC-1;	// 16bit^C}1 RyAf[^B
		bp[0x818e] = 0x77;		// 16bit^C}1 

		bp[0x2d8] |= 0x08;		// P23  TM1 

		bp[0x148] = 0x08;		// 16bit^C}1 NbN IN 1/1

		sndSetPowersave(1);
//		bp[0x2dd] &= ~0x02;		// P31 = LOW

		pceVectorSetTrap(23, sound_isr3);
	}

	stop_pcm();

	_pceWaveSetMasterAtt( 4 );			// -4dB

	for ( i = 0; i < MAXCH; i++ ) {
		_pceWaveSetChAtt( i, 4 );		// -4dB
	}

	pceVectorSetKs(KSNO_WaveCheckBuffs, _pceWaveDataCheckBuffs);
	pceVectorSetKs(KSNO_WaveDataOut, _pceWaveDataOut);
	pceVectorSetKs(KSNO_WaveAbort, _pceWaveAbort);
	pceVectorSetKs(KSNO_WaveSetChAtt, _pceWaveSetChAtt);
	pceVectorSetKs(KSNO_WaveSetMasterAtt, _pceWaveSetMasterAtt);
	pceVectorSetKs(KSNO_WaveStop, _pceWaveStop);
}

